



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>c++学习笔记---06--- 函数的重载</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">c++学习笔记---06--- 函数的重载</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 01:53:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>函数的重载</p>
<h2>函数的重载</h2>
<p>C++ 里的函数重载（overloading）机制比我们此前见到的东西都高深，这种语言的灵活性和强大功能在它身上体现得淋漓尽致。</p>
<p>所谓函数重载的实质就是用同样的名字再定义一个有着不同参数但有着同样用途的函数。（人格分裂、多重身份&hellip;&hellip;）</p>
<p>注意：可以是参数个数上的不同，也可以是参数数据类型上的不同！</p>
<p>实例演示：convertTemperature.cpp</p>
<div>
<pre class="prettyprint linenums"> #include &lt;iostream&gt;

 void convertTemperature(double tempIn, char typeIn);

 int main()<br />
 {<br />
     double tempIn;<br />
     char typeIn;

     std::cout &lt;&lt; "请以【xx.x C】或【xx.x F】的形式输入温度: ";<br />
       std::cin &gt;&gt; tempIn &gt;&gt; typeIn;<br />
       std::cin.ignore(, '\n');<br />
       std::cout &lt;&lt; "\n";

     convertTemperature(tempIn, typeIn);

     return ;<br />
 }

 void convertTemperature(double tempIn, char typeIn)<br />
 {<br />
       const unsigned short ADD_SUBTRACT = ;<br />
       const double RATIO = 9.0 / 5.0;

       float tempOut;<br />
       char typeOut;      

       switch( typeIn )<br />
       {<br />
       case 'C':<br />
       case 'c':<br />
             tempOut = (tempIn * RATIO) + ADD_SUBTRACT;<br />
             typeOut = 'F';<br />
             typeIn = 'C';<br />
             break;

       case 'F':<br />
       case 'f':<br />
             tempOut = (tempIn - ADD_SUBTRACT) / RATIO;<br />
             typeOut = 'C';<br />
             typeIn = 'F';<br />
             break;

       default:<br />
             typeOut = 'E';<br />
             break;<br />
       }

       if( typeOut != 'E' )<br />
       {<br />
             std::cout &lt;&lt; tempIn &lt;&lt; typeIn &lt;&lt; " = " &lt;&lt; tempOut &lt;&lt; typeOut &lt;&lt; "\n\n";<br />
       }<br />
       else<br />
       {<br />
             std::cout &lt;&lt; "请按照给出格式输入!" &lt;&lt; "\n\n";<br />
       }

       std::cout &lt;&lt; "请输入任意字符结束!" &lt;&lt; "\n";<br />
       std::cin.get();<br />
 }</pre>
</div>
<p>按照思路，我们自己试着来动手实现第一个函数的重载：convertTemperature_2.cpp</p>
<div>
<pre class="prettyprint linenums"> #include &lt;iostream&gt;

 void convertTemperature(double tempIn, char typeIn);<br />
 void convertTemperature(int tempIn, char typeIn);

 int main()<br />
 {<br />
     double tempIn;<br />
     int tempInInt;<br />
     char typeIn;

     std::cout &lt;&lt; "请以【xx.x C】或【xx.x F】的形式输入温度: ";<br />
       std::cin &gt;&gt; tempIn &gt;&gt; typeIn;<br />
       std::cin.ignore(, '\n');<br />
       std::cout &lt;&lt; "\n";<br />
     convertTemperature(tempIn, typeIn);

     std::cout &lt;&lt; "请以【xx C】或【xx F】的形式输入温度: ";<br />
       std::cin &gt;&gt; tempInInt &gt;&gt; typeIn;<br />
       std::cin.ignore(, '\n');<br />
       std::cout &lt;&lt; "\n";<br />
     convertTemperature(tempInInt, typeIn);

     return ;<br />
 }

 void convertTemperature(double tempIn, char typeIn)<br />
 {<br />
       const unsigned short ADD_SUBTRACT = ;<br />
       const double RATIO = 9.0 / 5.0;

       double tempOut;<br />
       char typeOut;      

       switch( typeIn )<br />
       {<br />
       case 'C':<br />
       case 'c':<br />
             tempOut = (tempIn * RATIO) + ADD_SUBTRACT;<br />
             typeOut = 'F';<br />
             typeIn = 'C';<br />
             break;

       case 'F':<br />
       case 'f':<br />
             tempOut = (tempIn - ADD_SUBTRACT) / RATIO;<br />
             typeOut = 'C';<br />
             typeIn = 'F';<br />
             break;

       default:<br />
             typeOut = 'E';<br />
             break;<br />
       }

       if( typeOut != 'E' )<br />
       {<br />
             std::cout &lt;&lt; tempIn &lt;&lt; typeIn &lt;&lt; " = " &lt;&lt; tempOut &lt;&lt; typeOut &lt;&lt; "\n\n";<br />
       }<br />
       else<br />
       {<br />
             std::cout &lt;&lt; "请按照给出格式输入!" &lt;&lt; "\n\n";<br />
       }

       std::cout &lt;&lt; "请输入任意字符结束!" &lt;&lt; "\n";<br />
       std::cin.get();<br />
 }

 void convertTemperature(int tempIn, char typeIn)<br />
 {<br />
       const unsigned short ADD_SUBTRACT = ;<br />
       const double RATIO = 9.0 / 5.0;

       int tempOut;<br />
       char typeOut;      

       switch( typeIn )<br />
       {<br />
       case 'C':<br />
       case 'c':<br />
             tempOut = (tempIn * RATIO) + ADD_SUBTRACT;<br />
             typeOut = 'F';<br />
             typeIn = 'C';<br />
             break;

       case 'F':<br />
       case 'f':<br />
             tempOut = (tempIn - ADD_SUBTRACT) / RATIO;<br />
             typeOut = 'C';<br />
             typeIn = 'F';<br />
             break;

       default:<br />
             typeOut = 'E';<br />
             break;<br />
       }

       if( typeOut != 'E' )<br />
       {<br />
             std::cout &lt;&lt; tempIn &lt;&lt; typeIn &lt;&lt; " = " &lt;&lt; tempOut &lt;&lt; typeOut &lt;&lt; "\n\n";<br />
       }<br />
       else<br />
       {<br />
             std::cout &lt;&lt; "请按照给出格式输入!" &lt;&lt; "\n\n";<br />
       }

       std::cout &lt;&lt; "请输入任意字符结束!" &lt;&lt; "\n";<br />
       std::cin.get();<br />
 }</pre>
</div>
<p>这个例子，我们可以体验到：对函数进行重载，事实上可以简化编程工作和提高代码可读性。</p>
<p>大家想必已经体会到重载的优越性了，事实上，重载不是一个真正的面向对象特征，它只是可以简化编程工作的一种方案，而简化工作正式C++ 语言的全部追求。</p>
<h2>有以下几点需要大家注意的：</h2>
<p>对函数（方法）进行重载一定要谨慎，不要&ldquo;无的放矢&rdquo;或&ldquo;乱点鸳鸯&rdquo;；</p>
<p>要知道重载函数越多，该程序就越不容易看懂；</p>
<p>注意区分重载和覆盖（覆盖后边我们会讲到）；</p>
<p>我们只能通过不同参数进行重载，但不能通过不同的返回值（尽管后者也是一种区别）；</p>
<p>最后，对函数进行重载的目的是为了方便对不同数据类型进行同样的处理。</p>
<p><strong>为什么不能通过返回值不同来重载函数（方法）呢？</strong></p>
<p>利用重载函数的方法设计一个程序，改程序通过函数&rdquo;calc()&rdquo;进行计算并返回显示结果。</p>
<p>当传入一个参数时，计算该参数的平方值；</p>
<p>当传入两个参数时，计算两个参数的积；</p>
<p>当传入三个参数时，计算三个参数的和。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jej448.html">【Beta】Scrum04</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2x24l9.html">C&plus;&plus;基础知识（4）---例外、异常处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy6edj8.html">Atiti &amp;&num;160&semi;attilax主要成果与解决方案与案例rsm版</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2145w8.html">Linux C Programing - Terminal&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m03x29.html">关于js中的几个小问题。</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx0rldq.html">创建第一个ArcGIS API for Silverlight应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok5rv59.html">c&num;中sqlhelper类的编写&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z3z469.html">C语言学习笔记--指针与字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kweo69.html">poj1611 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp6yx69.html">基于线程池的多线程售票demo2&period;0（原创）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlll41kq.html">Python 的反射机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlloodkq.html">解决多人开发时使用window&period;onload的覆盖问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn17w2q.html">MySQL服务器SSD性能问题分析与测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjld4p8.html">【笔记】DataTable或IList使用GroupBy方法的lamda表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn0kz4q.html">QList 列表指针的 释放</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm2mde9.html">Spring AOP课程实战</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7er7rj9.html">算法之杨辉三角形&lpar;Java语言&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnd55nx8.html">在项目中增加自定义icon图标</a>
		</li>
						<li><a href="https://www.batexi.com/a/qworx1z9.html">RN项目中缩进处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xepdv9.html">checked多选&comma;取消&comma;反选</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7z2r2e9.html">windows7下MongoDB（V3&period;4）的使用及仓储设计</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjgo728.html">Redis&mdash;&mdash;windows环境安装redis和redis sentinel部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z7l709.html">Linux入门之常用命令（10）软连接 硬链接</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo6d41q.html">郑厂长系列故事&mdash;&mdash;排兵布阵    hdu4539（状态压缩DP）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z7x0j9.html">解决子级用css float浮动 而父级div没高度不能自适应高度</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pl6ly8.html">bootstrap 的可编辑下拉框 jquery&period;editable-select</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojljl1q.html">Java Web开发&mdash;&mdash;MySQL数据库的安装与配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd2d279.html">谦先生的程序员日志之我的hadoop大数据生涯一</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyr4lj9.html">C＃委托</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gerpo48.html">基于HTML5及WebGL开发的2D3D第一人称漫游进行碰撞检测</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
